diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/config.mk u-boot-2011.06/arch/arm/config.mk
--- u-boot-2011.06_original/arch/arm/config.mk	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/config.mk	2014-07-29 17:28:38.819972000 +0800
@@ -21,7 +21,8 @@
 # MA 02111-1307 USA
 #
 
-CROSS_COMPILE ?= arm-linux-
+#CROSS_COMPILE ?= arm-linux-
+CROSS_COMPILE ?= arm-none-eabi-
 
 ifndef CONFIG_STANDALONE_LOAD_ADDR
 ifeq ($(SOC),omap3)
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/debug.c u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/debug.c
--- u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/debug.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/debug.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,18 @@
+#include <common.h>
+
+void debug_enable(void)
+{
+    unsigned long i;
+    asm ("mrc p15, 0, %0, c1, c1, 0":"=r" (i));
+    i |= 0x1;
+    asm ("mcr p15, 0, %0, c1, c1, 0": :"r" (i));
+}
+
+void debug_disable(void)
+{
+    unsigned long i;
+    asm ("mrc p15, 0, %0, c1, c1, 0":"=r" (i));
+    i &= (~0x1);
+    asm ("mcr p15, 0, %0, c1, c1, 0": :"r" (i));
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/interrupts.c u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/interrupts.c
--- u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/interrupts.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/interrupts.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,7 @@
+#include <common.h>
+
+void do_irq (struct pt_regs *pt_regs)
+{
+    cnc1800l_do_interrupt();
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/Makefile u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/Makefile
--- u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,46 @@
+#
+# (C) Copyright 2000-2006
+# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+#
+# See file CREDITS for list of people who contributed to this
+# project.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+# MA 02111-1307 USA
+#
+
+include $(TOPDIR)/config.mk
+
+LIB	= $(obj)lib$(SOC).o
+
+COBJS	= timer.o debug.o 
+SOBJS	= reset.o
+
+SRCS	:= $(SOBJS:.o=.S) $(COBJS:.o=.c)
+OBJS	:= $(addprefix $(obj),$(COBJS)) $(addprefix $(obj),$(SOBJS))
+
+all:	$(obj).depend $(LIB)
+
+$(LIB):	$(OBJS)
+	$(call cmd_link_o_target, $(OBJS))
+
+#########################################################################
+
+# defines $(obj).depend target
+include $(SRCTREE)/rules.mk
+
+sinclude $(obj).depend
+
+#########################################################################
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/reset.S u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/reset.S
--- u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/reset.S	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/reset.S	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,22 @@
+#include <config.h>
+/*
+ * Processor reset for Nomadik
+ */
+
+	.align 5
+.globl reset_cpu
+reset_cpu:
+	ldr  r1, WDT_BASE
+	mov  r2, #0
+	strh r2, [r1, #0x4]        /* WDT_TORR, minimum value */
+	strh r2, [r1, #0x6]
+	strh r2, [r1, #0x8]        /* WDT_CCVR, minimum value */
+	strh r2, [r1, #0xa]
+	mov  r2, #1
+	strh r2, [r1, #0x0]        /* WDT_CR, enable WDT and generated System Reset */
+
+_loop_forever:
+	b	_loop_forever
+
+WDT_BASE:
+	.word   0x801e1000
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/timer.c u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/timer.c
--- u-boot-2011.06_original/arch/arm/cpu/arm1176/cnc1800l/timer.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm1176/cnc1800l/timer.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,225 @@
+/*
+ * (C) Copyright 2003
+ * Texas Instruments <www.ti.com>
+ *
+ * (C) Copyright 2002
+ * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
+ * Marius Groeger <mgroeger@sysgo.de>
+ *
+ * (C) Copyright 2002
+ * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
+ * Alex Zuepke <azu@sysgo.de>
+ *
+ * (C) Copyright 2002-2004
+ * Gary Jennejohn, DENX Software Engineering, <gj@denx.de>
+ *
+ * (C) Copyright 2004
+ * Philippe Robin, ARM Ltd. <philippe.robin@arm.com>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+
+#define TIMER_CLOCK             (378000000 / 8)
+#define COUNT_TO_USEC(x)        ((x) * 4 / 189)
+#define USEC_TO_COUNT(x)        ((x) * 189 / 4)
+#define TICKS_PER_HZ            (TIMER_CLOCK / CONFIG_SYS_HZ)
+#define TICKS_TO_HZ(x)          ((x) / TICKS_PER_HZ)
+
+#define TIMER_LOAD_VAL 0xffffffff
+
+/* macro to read the decrementing 32 bit timer as an increasing count */
+#define READ_TIMER()  ((ulong)((ulong)0xffffffff - cnc1800l_apb_read32(CONFIG_SYS_TIMERBASE+4))) //
+
+static ulong timestamp;
+static ulong lastdec;
+
+/* ORION only support 8/16bit write to APB bus */
+static void cnc1800l_apb_write32(ulong addr, ulong data)
+{
+    *(volatile ushort *)(addr + 0) = (ushort)(data);
+    *(volatile ushort *)(addr + 2) = (ushort)(data >> 16);
+}
+
+static ulong cnc1800l_apb_read32(ulong addr)
+{
+
+    ulong timeval_high,timeval_high2, timeval;
+
+    timeval_high = *(volatile ushort *)(addr + 2);
+
+    timeval =  *(volatile ushort *)(addr);
+
+    timeval_high2= *((volatile ushort *)(addr + 2));
+
+    if (timeval_high2  != timeval_high) { 
+        timeval = (timeval_high2 << 16) | (*(volatile ushort *)(addr));
+    } 
+    else
+        timeval = timeval_high << 16 | timeval;
+
+
+    return timeval;
+}
+
+/* nothing really to do with interrupts, just starts up a counter. */
+int timer_init (void)
+{
+	cnc1800l_apb_write32((CONFIG_SYS_TIMERBASE + 0), CONFIG_SYS_TIMER_RELOAD);	/* TimerLoad */
+	cnc1800l_apb_write32((CONFIG_SYS_TIMERBASE + 4), CONFIG_SYS_TIMER_RELOAD);	/* TimerValue */
+	cnc1800l_apb_write32((CONFIG_SYS_TIMERBASE + 8), 0x1);
+
+	/* init the timestamp and lastdec value */
+	reset_timer_masked();
+
+	return 0;
+}
+
+/*
+ * timer without interrupts
+ */
+void reset_timer (void)
+{
+	reset_timer_masked ();
+}
+
+#if 0
+ulong get_timer (ulong base)
+{
+	return get_timer_masked () - base;
+}
+#else
+ulong get_timer (ulong base)
+{
+    return  TICKS_TO_HZ(READ_TIMER()) - base;
+}
+#endif
+
+ulong get_timer_u(ulong base)
+{
+	return COUNT_TO_USEC(READ_TIMER()- base);
+}
+
+void set_timer (ulong t)
+{
+	timestamp = t;
+}
+
+#if 0
+/* delay x useconds AND perserve advance timstamp value */
+void __udelay (unsigned long usec)
+{
+	ulong tmo, tmp;
+
+    tmo = usec * (CONFIG_SYS_PCLK_FREQ / (1000 * 1000));
+
+	tmp = get_timer (0);		/* get current timestamp */
+	if( (tmo + tmp + 1) < tmp )	/* if setting this fordward will roll time stamp */
+		reset_timer_masked ();	/* reset "advancing" timestamp to 0, set lastdec value */
+	else
+		tmo += tmp;		/* else, set advancing stamp wake up time */
+
+	while (get_timer_masked () < tmo)/* loop till event */
+		/*NOP*/;
+}
+#else
+void __udelay (unsigned long usec)
+{
+	ulong ini, end;
+
+	ini = READ_TIMER();
+	end = ini + USEC_TO_COUNT(usec);
+	while ((signed)(end - READ_TIMER()) > 0)
+		;
+}
+#endif
+
+void reset_timer_masked (void)
+{
+	/* reset time */
+	lastdec = READ_TIMER();  /* capure current decrementer value time */
+	timestamp = 0;	       /* start "advancing" time stamp from 0 */
+}
+
+#if 0
+ulong get_timer_masked (void)
+{
+	ulong now = READ_TIMER();		/* current tick value */
+
+	if (lastdec >= now) {		/* normal mode (non roll) */
+		/* normal mode */
+		timestamp += lastdec - now; /* move stamp fordward with absoulte diff ticks */
+	} else {			/* we have overflow of the count down timer */
+		/* nts = ts + ld + (TLV - now)
+		 * ts=old stamp, ld=time that passed before passing through -1
+		 * (TLV-now) amount of time after passing though -1
+		 * nts = new "advancing time stamp"...it could also roll and cause problems.
+		 */
+		timestamp += lastdec + TIMER_LOAD_VAL - now;
+	}
+	lastdec = now;
+
+	return timestamp;
+}
+
+/* waits specified delay value and resets timestamp */
+void udelay_masked (unsigned long usec)
+{
+	ulong tmo;
+	ulong endtime;
+	signed long diff;
+
+    tmo = usec * (CONFIG_SYS_HZ / (1000 * 1000));
+
+	endtime = get_timer_masked () + tmo;
+
+	do {
+		ulong now = get_timer_masked ();
+		diff = endtime - now;
+	} while (diff >= 0);
+}
+#endif
+
+/*
+ * This function is derived from PowerPC code (read timebase as long long).
+ * On ARM it just returns the timer value.
+ */
+unsigned long long get_ticks(void)
+{
+	return get_timer(0);
+}
+ 
+unsigned long long get_ticks_u(void)
+{
+	return get_timer_u(0);
+}
+
+
+/*
+ * This function is derived from PowerPC code (timebase clock frequency).
+ * On ARM it returns the number of timer ticks per second.
+ */
+ulong get_tbclk (void)
+{
+	ulong tbclk;
+
+	tbclk = CONFIG_SYS_HZ;
+	return tbclk;
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm1176/cpu.c u-boot-2011.06/arch/arm/cpu/arm1176/cpu.c
--- u-boot-2011.06_original/arch/arm/cpu/arm926ejs/csm1800h/interrupts.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm926ejs/csm1800h/interrupts.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,7 @@
+#include <common.h>
+
+void do_irq (struct pt_regs *pt_regs)
+{
+    orion_do_interrupt();
+}
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm926ejs/csm1800h/Makefile u-boot-2011.06/arch/arm/cpu/arm926ejs/csm1800h/Makefile
--- u-boot-2011.06_original/arch/arm/cpu/arm926ejs/csm1800h/Makefile	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm926ejs/csm1800h/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,46 @@
+#
+# (C) Copyright 2000-2006
+# Wolfgang Denk, DENX Software Engineering, wd@denx.de.
+#
+# See file CREDITS for list of people who contributed to this
+# project.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2 of
+# the License, or (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+# MA 02111-1307 USA
+#
+
+include $(TOPDIR)/config.mk
+
+LIB	= $(obj)lib$(SOC).o
+
+COBJS	= timer.o interrupts.o
+SOBJS	= reset.o
+
+SRCS	:= $(SOBJS:.o=.S) $(COBJS:.o=.c)
+OBJS	:= $(addprefix $(obj),$(COBJS)) $(addprefix $(obj),$(SOBJS))
+
+all:	$(obj).depend $(LIB)
+
+$(LIB):	$(OBJS)
+	$(call cmd_link_o_target, $(OBJS))
+
+#########################################################################
+
+# defines $(obj).depend target
+include $(SRCTREE)/rules.mk
+
+sinclude $(obj).depend
+
+#########################################################################
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm926ejs/csm1800h/reset.S u-boot-2011.06/arch/arm/cpu/arm926ejs/csm1800h/reset.S
--- u-boot-2011.06_original/arch/arm/cpu/arm926ejs/csm1800h/reset.S	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm926ejs/csm1800h/reset.S	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,22 @@
+#include <config.h>
+/*
+ * Processor reset for Nomadik
+ */
+
+	.align 5
+.globl reset_cpu
+reset_cpu:
+	ldr  r1, WDT_BASE
+	mov  r2, #0
+	strh r2, [r1, #0x4]        /* WDT_TORR, minimum value */
+	strh r2, [r1, #0x6]
+	strh r2, [r1, #0x8]        /* WDT_CCVR, minimum value */
+	strh r2, [r1, #0xa]
+	mov  r2, #1
+	strh r2, [r1, #0x0]        /* WDT_CR, enable WDT and generated System Reset */
+
+_loop_forever:
+	b	_loop_forever
+
+WDT_BASE:
+	.word   0x101e1000
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm926ejs/csm1800h/timer.c u-boot-2011.06/arch/arm/cpu/arm926ejs/csm1800h/timer.c
--- u-boot-2011.06_original/arch/arm/cpu/arm926ejs/csm1800h/timer.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm926ejs/csm1800h/timer.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,201 @@
+/*
+ * (C) Copyright 2003
+ * Texas Instruments <www.ti.com>
+ *
+ * (C) Copyright 2002
+ * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
+ * Marius Groeger <mgroeger@sysgo.de>
+ *
+ * (C) Copyright 2002
+ * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
+ * Alex Zuepke <azu@sysgo.de>
+ *
+ * (C) Copyright 2002-2004
+ * Gary Jennejohn, DENX Software Engineering, <gj@denx.de>
+ *
+ * (C) Copyright 2004
+ * Philippe Robin, ARM Ltd. <philippe.robin@arm.com>
+ *
+ * See file CREDITS for list of people who contributed to this
+ * project.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of
+ * the License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
+ * MA 02111-1307 USA
+ */
+
+#include <common.h>
+
+#define TIMER_CLOCK             (378000000 / 8)
+#define COUNT_TO_USEC(x)        ((x) * 4 / 189)
+#define USEC_TO_COUNT(x)        ((x) * 189 / 4)
+#define TICKS_PER_HZ            (TIMER_CLOCK / CONFIG_SYS_HZ)
+#define TICKS_TO_HZ(x)          ((x) / TICKS_PER_HZ)
+
+#define TIMER_LOAD_VAL 0xffffffff
+
+/* macro to read the decrementing 32 bit timer as an increasing count */
+#define READ_TIMER()  (0 - orion_apb_read32(CONFIG_SYS_TIMERBASE+4))
+
+static ulong timestamp;
+static ulong lastdec;
+
+/* ORION only support 8/16bit write to APB bus */
+static void orion_apb_write32(ulong addr, ulong data)
+{
+    *(volatile ushort *)(addr + 0) = (ushort)(data);
+    *(volatile ushort *)(addr + 2) = (ushort)(data >> 16);
+}
+
+static ulong orion_apb_read32(ulong addr)
+{
+    ulong data;
+    data  = *(volatile ushort *)(addr + 0);
+    data |= (*(volatile ushort *)(addr + 2) << 16);
+    return data;
+}
+
+/* nothing really to do with interrupts, just starts up a counter. */
+int timer_init (void)
+{
+	orion_apb_write32((CONFIG_SYS_TIMERBASE + 0), CONFIG_SYS_TIMER_RELOAD);	/* TimerLoad */
+	orion_apb_write32((CONFIG_SYS_TIMERBASE + 4), CONFIG_SYS_TIMER_RELOAD);	/* TimerValue */
+	orion_apb_write32((CONFIG_SYS_TIMERBASE + 8), 0x1);
+
+	/* init the timestamp and lastdec value */
+	reset_timer_masked();
+
+	return 0;
+}
+
+/*
+ * timer without interrupts
+ */
+void reset_timer (void)
+{
+	reset_timer_masked ();
+}
+
+#if 0
+ulong get_timer (ulong base)
+{
+	return get_timer_masked () - base;
+}
+#else
+ulong get_timer (ulong base)
+{
+    return  TICKS_TO_HZ(READ_TIMER()) - base;
+}
+#endif
+
+void set_timer (ulong t)
+{
+	timestamp = t;
+}
+
+#if 0
+/* delay x useconds AND perserve advance timstamp value */
+void __udelay (unsigned long usec)
+{
+	ulong tmo, tmp;
+
+    tmo = usec * (CONFIG_SYS_PCLK_FREQ / (1000 * 1000));
+
+	tmp = get_timer (0);		/* get current timestamp */
+	if( (tmo + tmp + 1) < tmp )	/* if setting this fordward will roll time stamp */
+		reset_timer_masked ();	/* reset "advancing" timestamp to 0, set lastdec value */
+	else
+		tmo += tmp;		/* else, set advancing stamp wake up time */
+
+	while (get_timer_masked () < tmo)/* loop till event */
+		/*NOP*/;
+}
+#else
+void __udelay (unsigned long usec)
+{
+	ulong ini, end;
+
+	ini = READ_TIMER();
+	end = ini + USEC_TO_COUNT(usec);
+	while ((signed)(end - READ_TIMER()) > 0)
+		;
+}
+#endif
+
+void reset_timer_masked (void)
+{
+	/* reset time */
+	lastdec = READ_TIMER();  /* capure current decrementer value time */
+	timestamp = 0;	       /* start "advancing" time stamp from 0 */
+}
+
+#if 0
+ulong get_timer_masked (void)
+{
+	ulong now = READ_TIMER();		/* current tick value */
+
+	if (lastdec >= now) {		/* normal mode (non roll) */
+		/* normal mode */
+		timestamp += lastdec - now; /* move stamp fordward with absoulte diff ticks */
+	} else {			/* we have overflow of the count down timer */
+		/* nts = ts + ld + (TLV - now)
+		 * ts=old stamp, ld=time that passed before passing through -1
+		 * (TLV-now) amount of time after passing though -1
+		 * nts = new "advancing time stamp"...it could also roll and cause problems.
+		 */
+		timestamp += lastdec + TIMER_LOAD_VAL - now;
+	}
+	lastdec = now;
+
+	return timestamp;
+}
+
+/* waits specified delay value and resets timestamp */
+void udelay_masked (unsigned long usec)
+{
+	ulong tmo;
+	ulong endtime;
+	signed long diff;
+
+    tmo = usec * (CONFIG_SYS_HZ / (1000 * 1000));
+
+	endtime = get_timer_masked () + tmo;
+
+	do {
+		ulong now = get_timer_masked ();
+		diff = endtime - now;
+	} while (diff >= 0);
+}
+#endif
+
+/*
+ * This function is derived from PowerPC code (read timebase as long long).
+ * On ARM it just returns the timer value.
+ */
+unsigned long long get_ticks(void)
+{
+	return get_timer(0);
+}
+
+/*
+ * This function is derived from PowerPC code (timebase clock frequency).
+ * On ARM it returns the number of timer ticks per second.
+ */
+ulong get_tbclk (void)
+{
+	ulong tbclk;
+
+	tbclk = CONFIG_SYS_HZ;
+	return tbclk;
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/arm926ejs/start.S u-boot-2011.06/arch/arm/cpu/arm926ejs/start.S
--- u-boot-2011.06_original/arch/arm/cpu/arm926ejs/start.S	2011-06-28 04:22:42.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/arm926ejs/start.S	2014-07-29 17:28:38.819972000 +0800
@@ -175,6 +175,24 @@
 	bl	cpu_init_crit
 #endif
 
+#ifdef CONFIG_ARCH_CSM1800
+
+#define PINMUX_UART_ENABLE     0x42110008
+#define PINMUX_ETHER_ENABLE    0x42110020
+
+/* set pinmux to enable uart 0 */
+	ldr  r0,=(PINMUX_UART_ENABLE)
+	mov  r1,#1
+	str  r1,[r0]
+
+/* set pinmux to enable ethernet */
+	ldr  r0,=(PINMUX_ETHER_ENABLE)
+	mov  r1,#0
+	str  r1,[r0]
+
+
+#endif
+
 /* Set stackpointer in internal RAM to call board_init_f */
 call_board_init_f:
 	ldr	sp, =(CONFIG_SYS_INIT_SP_ADDR)
@@ -268,9 +286,10 @@
 	add	r0, r0, #4
 	cmp	r0, r1
 	bne	clbss_l
-
+/*
 	bl coloured_LED_init
 	bl red_LED_on
+*/
 #endif
 
 /*
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/cache_v7.c u-boot-2011.06/arch/arm/cpu/armv7/cache_v7.c
--- u-boot-2011.06_original/arch/arm/cpu/armv7/cache_v7.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/cache_v7.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,394 @@
+/*
+ * (C) Copyright 2010
+ * Texas Instruments, <www.ti.com>
+ * Aneesh V <aneesh@ti.com>
+ *
+ * SPDX-License-Identifier:	GPL-2.0+
+ */
+#include <linux/types.h>
+#include <common.h>
+#include <asm/armv7.h>
+#include <asm/utils.h>
+
+#define ARMV7_DCACHE_INVAL_ALL		1
+#define ARMV7_DCACHE_CLEAN_INVAL_ALL	2
+#define ARMV7_DCACHE_INVAL_RANGE	3
+#define ARMV7_DCACHE_CLEAN_INVAL_RANGE	4
+
+#ifndef CONFIG_SYS_DCACHE_OFF
+/*
+ * Write the level and type you want to Cache Size Selection Register(CSSELR)
+ * to get size details from Current Cache Size ID Register(CCSIDR)
+ */
+static void set_csselr(u32 level, u32 type)
+{	u32 csselr = level << 1 | type;
+
+	/* Write to Cache Size Selection Register(CSSELR) */
+	asm volatile ("mcr p15, 2, %0, c0, c0, 0" : : "r" (csselr));
+}
+
+static u32 get_ccsidr(void)
+{
+	u32 ccsidr;
+
+	/* Read current CP15 Cache Size ID Register */
+	asm volatile ("mrc p15, 1, %0, c0, c0, 0" : "=r" (ccsidr));
+	return ccsidr;
+}
+
+static u32 get_clidr(void)
+{
+	u32 clidr;
+
+	/* Read current CP15 Cache Level ID Register */
+	asm volatile ("mrc p15,1,%0,c0,c0,1" : "=r" (clidr));
+	return clidr;
+}
+
+static void v7_inval_dcache_level_setway(u32 level, u32 num_sets,
+					 u32 num_ways, u32 way_shift,
+					 u32 log2_line_len)
+{
+	int way, set, setway;
+
+	/*
+	 * For optimal assembly code:
+	 *	a. count down
+	 *	b. have bigger loop inside
+	 */
+	for (way = num_ways - 1; way >= 0 ; way--) {
+		for (set = num_sets - 1; set >= 0; set--) {
+			setway = (level << 1) | (set << log2_line_len) |
+				 (way << way_shift);
+			/* Invalidate data/unified cache line by set/way */
+			asm volatile ("	mcr p15, 0, %0, c7, c6, 2"
+					: : "r" (setway));
+		}
+	}
+	/* DSB to make sure the operation is complete */
+	CP15DSB;
+}
+
+static void v7_clean_inval_dcache_level_setway(u32 level, u32 num_sets,
+					       u32 num_ways, u32 way_shift,
+					       u32 log2_line_len)
+{
+	int way, set, setway;
+
+	/*
+	 * For optimal assembly code:
+	 *	a. count down
+	 *	b. have bigger loop inside
+	 */
+	for (way = num_ways - 1; way >= 0 ; way--) {
+		for (set = num_sets - 1; set >= 0; set--) {
+			setway = (level << 1) | (set << log2_line_len) |
+				 (way << way_shift);
+			/*
+			 * Clean & Invalidate data/unified
+			 * cache line by set/way
+			 */
+			asm volatile ("	mcr p15, 0, %0, c7, c14, 2"
+					: : "r" (setway));
+		}
+	}
+	/* DSB to make sure the operation is complete */
+	CP15DSB;
+}
+
+static void v7_maint_dcache_level_setway(u32 level, u32 operation)
+{
+	u32 ccsidr;
+	u32 num_sets, num_ways, log2_line_len, log2_num_ways;
+	u32 way_shift;
+
+	set_csselr(level, ARMV7_CSSELR_IND_DATA_UNIFIED);
+
+	ccsidr = get_ccsidr();
+
+	log2_line_len = ((ccsidr & CCSIDR_LINE_SIZE_MASK) >>
+				CCSIDR_LINE_SIZE_OFFSET) + 2;
+	/* Converting from words to bytes */
+	log2_line_len += 2;
+
+	num_ways  = ((ccsidr & CCSIDR_ASSOCIATIVITY_MASK) >>
+			CCSIDR_ASSOCIATIVITY_OFFSET) + 1;
+	num_sets  = ((ccsidr & CCSIDR_NUM_SETS_MASK) >>
+			CCSIDR_NUM_SETS_OFFSET) + 1;
+	/*
+	 * According to ARMv7 ARM number of sets and number of ways need
+	 * not be a power of 2
+	 */
+	log2_num_ways = log_2_n_round_up(num_ways);
+
+	way_shift = (32 - log2_num_ways);
+	if (operation == ARMV7_DCACHE_INVAL_ALL) {
+		v7_inval_dcache_level_setway(level, num_sets, num_ways,
+				      way_shift, log2_line_len);
+	} else if (operation == ARMV7_DCACHE_CLEAN_INVAL_ALL) {
+		v7_clean_inval_dcache_level_setway(level, num_sets, num_ways,
+						   way_shift, log2_line_len);
+	}
+}
+
+static void v7_maint_dcache_all(u32 operation)
+{
+	u32 level, cache_type, level_start_bit = 0;
+
+	u32 clidr = get_clidr();
+
+	for (level = 0; level < 7; level++) {
+		cache_type = (clidr >> level_start_bit) & 0x7;
+		if ((cache_type == ARMV7_CLIDR_CTYPE_DATA_ONLY) ||
+		    (cache_type == ARMV7_CLIDR_CTYPE_INSTRUCTION_DATA) ||
+		    (cache_type == ARMV7_CLIDR_CTYPE_UNIFIED))
+			v7_maint_dcache_level_setway(level, operation);
+		level_start_bit += 3;
+	}
+}
+
+static void v7_dcache_clean_inval_range(u32 start,
+					u32 stop, u32 line_len)
+{
+	u32 mva;
+
+	/* Align start to cache line boundary */
+	start &= ~(line_len - 1);
+	for (mva = start; mva < stop; mva = mva + line_len) {
+		/* DCCIMVAC - Clean & Invalidate data cache by MVA to PoC */
+		asm volatile ("mcr p15, 0, %0, c7, c14, 1" : : "r" (mva));
+	}
+}
+
+static void v7_dcache_inval_range(u32 start, u32 stop, u32 line_len)
+{
+	u32 mva;
+
+	/*
+	 * If start address is not aligned to cache-line do not
+	 * invalidate the first cache-line
+	 */
+	if (start & (line_len - 1)) {
+		printf("ERROR: %s - start address is not aligned - 0x%08x\n",
+			__func__, start);
+		/* move to next cache line */
+		start = (start + line_len - 1) & ~(line_len - 1);
+	}
+
+	/*
+	 * If stop address is not aligned to cache-line do not
+	 * invalidate the last cache-line
+	 */
+	if (stop & (line_len - 1)) {
+		printf("ERROR: %s - stop address is not aligned - 0x%08x\n",
+			__func__, stop);
+		/* align to the beginning of this cache line */
+		stop &= ~(line_len - 1);
+	}
+
+	for (mva = start; mva < stop; mva = mva + line_len) {
+		/* DCIMVAC - Invalidate data cache by MVA to PoC */
+		asm volatile ("mcr p15, 0, %0, c7, c6, 1" : : "r" (mva));
+	}
+}
+
+static void v7_dcache_maint_range(u32 start, u32 stop, u32 range_op)
+{
+	u32 line_len, ccsidr;
+
+	ccsidr = get_ccsidr();
+	line_len = ((ccsidr & CCSIDR_LINE_SIZE_MASK) >>
+			CCSIDR_LINE_SIZE_OFFSET) + 2;
+	/* Converting from words to bytes */
+	line_len += 2;
+	/* converting from log2(linelen) to linelen */
+	line_len = 1 << line_len;
+
+	switch (range_op) {
+	case ARMV7_DCACHE_CLEAN_INVAL_RANGE:
+		v7_dcache_clean_inval_range(start, stop, line_len);
+		break;
+	case ARMV7_DCACHE_INVAL_RANGE:
+		v7_dcache_inval_range(start, stop, line_len);
+		break;
+	}
+
+	/* DSB to make sure the operation is complete */
+	CP15DSB;
+}
+
+/* Invalidate TLB */
+static void v7_inval_tlb(void)
+{
+	/* Invalidate entire unified TLB */
+	asm volatile ("mcr p15, 0, %0, c8, c7, 0" : : "r" (0));
+	/* Invalidate entire data TLB */
+	asm volatile ("mcr p15, 0, %0, c8, c6, 0" : : "r" (0));
+	/* Invalidate entire instruction TLB */
+	asm volatile ("mcr p15, 0, %0, c8, c5, 0" : : "r" (0));
+	/* Full system DSB - make sure that the invalidation is complete */
+	CP15DSB;
+	/* Full system ISB - make sure the instruction stream sees it */
+	CP15ISB;
+}
+
+void invalidate_dcache_all(void)
+{
+	v7_maint_dcache_all(ARMV7_DCACHE_INVAL_ALL);
+
+	v7_outer_cache_inval_all();
+}
+
+/*
+ * Performs a clean & invalidation of the entire data cache
+ * at all levels
+ */
+void flush_dcache_all(void)
+{
+	v7_maint_dcache_all(ARMV7_DCACHE_CLEAN_INVAL_ALL);
+
+	v7_outer_cache_flush_all();
+}
+
+/*
+ * Invalidates range in all levels of D-cache/unified cache used:
+ * Affects the range [start, stop - 1]
+ */
+void invalidate_dcache_range(unsigned long start, unsigned long stop)
+{
+
+	v7_dcache_maint_range(start, stop, ARMV7_DCACHE_INVAL_RANGE);
+
+	v7_outer_cache_inval_range(start, stop);
+}
+
+/*
+ * Flush range(clean & invalidate) from all levels of D-cache/unified
+ * cache used:
+ * Affects the range [start, stop - 1]
+ */
+void flush_dcache_range(unsigned long start, unsigned long stop)
+{
+	v7_dcache_maint_range(start, stop, ARMV7_DCACHE_CLEAN_INVAL_RANGE);
+
+	v7_outer_cache_flush_range(start, stop);
+}
+
+void arm_init_before_mmu(void)
+{
+	v7_outer_cache_enable();
+	invalidate_dcache_all();
+	v7_inval_tlb();
+}
+
+void mmu_page_table_flush(unsigned long start, unsigned long stop)
+{
+	flush_dcache_range(start, stop);
+	v7_inval_tlb();
+}
+
+/*
+ * Flush range from all levels of d-cache/unified-cache used:
+ * Affects the range [start, start + size - 1]
+ */
+void  flush_cache(unsigned long start, unsigned long size)
+{
+	flush_dcache_range(start, start + size);
+}
+#else /* #ifndef CONFIG_SYS_DCACHE_OFF */
+void invalidate_dcache_all(void)
+{
+}
+
+void flush_dcache_all(void)
+{
+}
+
+void invalidate_dcache_range(unsigned long start, unsigned long stop)
+{
+}
+
+void flush_dcache_range(unsigned long start, unsigned long stop)
+{
+}
+
+void arm_init_before_mmu(void)
+{
+}
+
+void  flush_cache(unsigned long start, unsigned long size)
+{
+}
+
+void mmu_page_table_flush(unsigned long start, unsigned long stop)
+{
+}
+
+void arm_init_domains(void)
+{
+}
+#endif /* #ifndef CONFIG_SYS_DCACHE_OFF */
+
+#ifndef CONFIG_SYS_ICACHE_OFF
+/* Invalidate entire I-cache and branch predictor array */
+void invalidate_icache_all(void)
+{
+	/*
+	 * Invalidate all instruction caches to PoU.
+	 * Also flushes branch target cache.
+	 */
+	asm volatile ("mcr p15, 0, %0, c7, c5, 0" : : "r" (0));
+
+	/* Invalidate entire branch predictor array */
+	asm volatile ("mcr p15, 0, %0, c7, c5, 6" : : "r" (0));
+
+	/* Full system DSB - make sure that the invalidation is complete */
+	CP15DSB;
+
+	/* ISB - make sure the instruction stream sees it */
+	CP15ISB;
+}
+#else
+void invalidate_icache_all(void)
+{
+}
+#endif
+
+/*
+ * Stub implementations for outer cache operations
+ */
+void __v7_outer_cache_enable(void)
+{
+}
+void v7_outer_cache_enable(void)
+	__attribute__((weak, alias("__v7_outer_cache_enable")));
+
+void __v7_outer_cache_disable(void)
+{
+}
+void v7_outer_cache_disable(void)
+	__attribute__((weak, alias("__v7_outer_cache_disable")));
+
+void __v7_outer_cache_flush_all(void)
+{
+}
+void v7_outer_cache_flush_all(void)
+	__attribute__((weak, alias("__v7_outer_cache_flush_all")));
+
+void __v7_outer_cache_inval_all(void)
+{
+}
+void v7_outer_cache_inval_all(void)
+	__attribute__((weak, alias("__v7_outer_cache_inval_all")));
+
+void __v7_outer_cache_flush_range(u32 start, u32 end)
+{
+}
+void v7_outer_cache_flush_range(u32 start, u32 end)
+	__attribute__((weak, alias("__v7_outer_cache_flush_range")));
+
+void __v7_outer_cache_inval_range(u32 start, u32 end)
+{
+}
+void v7_outer_cache_inval_range(u32 start, u32 end)
+	__attribute__((weak, alias("__v7_outer_cache_inval_range")));
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/interrupts.c u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/interrupts.c
--- u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/interrupts.c	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/interrupts.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,6 @@
+#include <common.h>
+void do_irq (struct pt_regs *pt_regs)
+{
+    extern int cnc1900_do_interrupt(void);
+    cnc1900_do_interrupt();
+}
diff '--exclude=.svn' -Naur u-boot-2011.06_original/arch/arm/cpu/armv7/cnc1900/Makefile u-boot-2011.06/arch/arm/cpu/armv7/cnc1900/Makefile
